#ifndef _GLWIDGET_H
#define _GLWIDGET_H

#include <QtOpenGL/QGLWidget>
#include <GL/glu.h>
#include <QTime>
#include <QTimer>

class GLWidget : public QGLWidget {

    Q_OBJECT // must include this if you use Qt signals/slots

public:
    GLWidget(QWidget *parent = NULL);

    double xmin, xmax, ymin, ymax;  // Coordinates in window
    double alpha, beta;         // Angles of rotation
    int mouseX, mouseY;         // Previous mouse position

    QTimer* timer;
    QTime animationTime;

    // Animation
    GLfloat earthSpin;     // Angle of Earth rotation
    GLfloat moonAlpha;     // Moon orbit position
    GLfloat moonSpin;      // Angle of Moon rotation

    GLUquadricObj* quadric; // Quadric object used to draw a sphere

protected:
    void initializeGL();
    void resizeGL(int w, int h);
    void paintGL();
    void mousePressEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void keyPressEvent(QKeyEvent *event);
    void render();

public slots:
    void animate();
};

#endif  /* _GLWIDGET_H */
